VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
END
Attribute VB_Name = "Connect"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = True
Attribute VB_Description = "Clear Code Windows"
Option Explicit

Implements IDTExtensibility

Private VBInstance                        As VBIDE.VBE
Private mcbWiperButton                    As Office.CommandBarControl
Private mcbWiperMenu                      As Office.CommandBarControl

Private WithEvents WiperButtonHandler     As CommandBarEvents
Attribute WiperButtonHandler.VB_VarHelpID = -1
Private WithEvents WiperMenuHandler       As CommandBarEvents
Attribute WiperMenuHandler.VB_VarHelpID = -1

Private Sub IDTExtensibility_OnAddInsUpdate(Custom() As Variant)
  ' placeholder for this procedure so it doesn't get optimized out during compile
End Sub

Private Sub IDTExtensibility_OnConnection(ByVal VBInstancenst As Object, _
                        ByVal ConnectMode As VBIDE.vbext_ConnectMode, _
                        ByVal AddInInst As VBIDE.AddIn, _
                        Custom() As Variant)
On Error Resume Next

   Set VBInstance = VBInstancenst
   
   ' Create Toolbar Button On Standard Toolbar
   Set mcbWiperButton = VBInstance.CommandBars("Standard").Controls.Add(1, , , 20)
   mcbWiperButton.Enabled = False
   Clipboard.SetData LoadResPicture(1000, 0)  '// Put image on Clipboard
   mcbWiperButton.PasteFace
   mcbWiperButton.ToolTipText = "Clear Code Windows"
   Set WiperButtonHandler = VBInstance.Events.CommandBarEvents(mcbWiperButton)

   ' Create Menu Item on Add-In's Menu
   Set mcbWiperMenu = VBInstance.CommandBars("Add-Ins").Controls.Add
   mcbWiperMenu.Enabled = False
   mcbWiperMenu.PasteFace
   mcbWiperMenu.Caption = "Clear Code Windows"
   Set WiperMenuHandler = VBInstance.Events.CommandBarEvents(mcbWiperMenu)

   ' Enable The Wiper Controls
   mcbWiperMenu.Enabled = True
   mcbWiperButton.Enabled = True
   
End Sub

Private Sub IDTExtensibility_OnDisconnection(ByVal RemoveMode As VBIDE.vbext_DisconnectMode, _
                        Custom() As Variant)
On Error Resume Next
   ' Disconnect Wiper Controls
   mcbWiperButton.Delete
   mcbWiperMenu.Delete
   Set VBInstance = Nothing
   Set mcbWiperButton = Nothing
   Set mcbWiperMenu = Nothing

End Sub

Private Sub IDTExtensibility_OnStartupComplete(Custom() As Variant)
  ' placeholder for this procedure so it doesn't get optimized out during compile
End Sub

Private Sub WiperButtonHandler_Click(ByVal CommandBarControl As Object, _
                                     Handled As Boolean, _
                                     CancelDefault As Boolean)
   Dim pWindow As VBIDE.Window
    
   For Each pWindow In VBInstance.Windows
      If pWindow.Type = vbext_wt_CodeWindow Then
         pWindow.Close
      End If
   Next pWindow
    
   Set pWindow = Nothing

End Sub

Private Sub WiperMenuHandler_Click(ByVal CommandBarControl As Object, _
                                   Handled As Boolean, _
                                   CancelDefault As Boolean)
   ' Re-sse WiperButtonHandler_Click()
   Call WiperButtonHandler_Click(ByVal CommandBarControl, Handled, CancelDefault)

End Sub

