Attribute VB_Name = "MRegWiper"
' ------------------------------------------------------------------------
' Copyright  1997 Microsoft Corporation. All rights reserved.
'
' You have a royalty-free right to use, modify, reproduce and distribute
' the Sample Application Files (and/or any modified version) in any way
' you find useful, provided that you agree that Microsoft has no warranty,
' obligations or liability for any Sample Application Files.
' ------------------------------------------------------------------------

Option Explicit

Declare Function OpenProcess Lib "kernel32" ( _
    ByVal dwDesiredAccess As Long, ByVal bInheritHandle As Long, _
    ByVal dwProcessId As Long) As Long
Declare Function GetExitCodeProcess Lib "kernel32" ( _
    ByVal hProcess As Long, lpExitCode As Long) As Long
Declare Function CloseHandle Lib "kernel32" ( _
    ByVal hObject As Long) As Long
Declare Function WritePrivateProfileString Lib "kernel32" _
    Alias "WritePrivateProfileStringA" (ByVal AppName As String, _
    ByVal KeyName As String, ByVal KeyDefault As String, _
    ByVal FileName As String) As Long
Const STILL_ACTIVE = &H103
Const PROCESS_QUERY_INFORMATION = &H400

Sub Main()
    Dim id As Long
    id = Shell("regsvr32.exe /s ClearCodeWindows.dll", vbHide)
    Do While IsRunning(id)
        DoEvents
    Loop
    Call WritePrivateProfileString("Add-Ins32", "ClearCodeWindows.Connect", "1", "VBADDIN.INI")
End Sub

Function IsRunning(idProg As Long) As Boolean
    Dim idProc As Long, iRet As Long
    ' Get process handle
    idProc = OpenProcess(PROCESS_QUERY_INFORMATION, False, idProg)
    ' Check status of process
    If idProc <> 0 Then GetExitCodeProcess idProc, iRet
    IsRunning = (iRet = STILL_ACTIVE)
    CloseHandle idProc
End Function

